Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 841641 - sys-apps/portage: --keep-going fails to consider different versions of packages from those scheduled to merge
Summary: sys-apps/portage: --keep-going fails to consider different versions of packag...
Status: CONFIRMED
Alias: None
Product: Portage Development
Classification: Unclassified
Component: Core (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: 373807
  Show dependency tree
 
Reported: 2022-04-29 09:26 UTC by dE
Modified: 2022-04-30 00:42 UTC (History)
1 user (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
emerge -j2 --debug --getbinpkg --keep-going --update --deep world &> /tmp/crash.log (crash.log.xz,457.81 KB, application/x-xz)
2022-04-29 09:26 UTC, dE
Details

Note You need to log in before you can comment on or make changes to this bug.
Description dE 2022-04-29 09:26:37 UTC
Created attachment 775305 [details]
emerge -j2 --debug --getbinpkg --keep-going --update --deep world &> /tmp/crash.log

In case a build failed because of whatsoever requirements where not met in the ebuild, then --keep-going doesn't work.

This seems to appear only in the latest version of portage.

I further get a stack trace -- 
ERROR:asyncio:Task was destroyed but it is pending!
task: <Task pending name='Task-124' coro=<SpawnProcess._main() running at /usr/lib/python3.9/site-packages/_emerge/SpawnProcess.py:180> wait_for=<Future pending cb=[AsynchronousTask.async_wait.<locals>.<lambda>() at /usr/lib/python3.9/site-packages/_emerge/AsynchronousTask.py:49, <TaskWakeupMethWrapper object at 0x7f83d4ea6430>()]> cb=[SpawnProcess._main_exit()]>
ERROR:asyncio:Task was destroyed but it is pending!
task: <Task pending name='Task-123' coro=<PipeLogger._io_loop() running at /usr/lib/python3.9/site-packages/portage/util/_async/PipeLogger.py:99> wait_for=<Future pending cb=[<TaskWakeupMethWrapper object at 0x7f83d4ea6610>()]> cb=[PipeLogger._io_loop_done()]>
ERROR:asyncio:Task was destroyed but it is pending!
task: <Task pending name='Task-122' coro=<BuildLogger._main() running at /usr/lib/python3.9/site-packages/portage/util/_async/BuildLogger.py:101> wait_for=<Future pending cb=[AsynchronousTask.async_wait.<locals>.<lambda>() at /usr/lib/python3.9/site-packages/_emerge/AsynchronousTask.py:49, <TaskWakeupMethWrapper object at 0x7f83d4ea65e0>()]> cb=[BuildLogger._main_exit()]>
ERROR:asyncio:Task was destroyed but it is pending!
task: <Task pending name='Task-121' coro=<PipeLogger._io_loop() running at /usr/lib/python3.9/site-packages/portage/util/_async/PipeLogger.py:99> wait_for=<Future pending cb=[<TaskWakeupMethWrapper object at 0x7f83d4ea68e0>()]> cb=[PipeLogger._io_loop_done()]>

Portage 3.0.30 (python 3.9.9-final-0, default/linux/amd64/17.1/desktop/plasma/systemd, gcc-11.2.1, glibc-2.34-r7, 5.10.87-gentoo-gentoo x86_64)
=================================================================
System uname: Linux-5.10.87-gentoo-gentoo-x86_64-Intel-R-_Core-TM-_i7-3770_CPU_@_3.40GHz-with-glibc2.34
KiB Mem:     8084280 total,   4659696 free
KiB Swap:    5242876 total,   5242876 free
Timestamp of repository gentoo: Wed, 27 Apr 2022 00:45:01 +0000
Head commit of repository gentoo: ae61075e7fb307c5f13810963099df88f99df426
sh bash 5.1_p16
ld GNU ld (Gentoo 2.37_p1 p2) 2.37
ccache version 4.5.1 [enabled]
app-misc/pax-utils:        1.3.3::gentoo
app-shells/bash:           5.1_p16::gentoo
dev-java/java-config:      2.3.1::gentoo
dev-lang/perl:             5.34.0-r6::gentoo
dev-lang/python:           3.9.9-r1::gentoo
dev-util/ccache:           4.5.1::gentoo
sys-apps/baselayout:       2.8::gentoo
sys-apps/openrc:           0.44.10::gentoo
sys-apps/sandbox:          2.25::gentoo
sys-apps/systemd:          249.9::gentoo
sys-devel/binutils:        2.37_p1-r2::gentoo
sys-devel/binutils-config: 5.4::gentoo
sys-devel/gcc:             11.2.1_p20220115::gentoo
sys-devel/gcc-config:      2.5-r1::gentoo
sys-devel/make:            4.3::gentoo
sys-kernel/linux-headers:  5.10::gentoo (virtual/os-headers)
sys-libs/glibc:            2.34-r7::gentoo
sys-libs/libselinux:       3.3::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-verify-jobs: 1
    sync-rsync-verify-max-age: 24
    sync-rsync-verify-metamanifest: no
    sync-rsync-extra-opts: 

oubliette
    location: /var/lib/layman/oubliette
    masters: gentoo
    priority: 50

ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=native -fomit-frame-pointer -floop-interchange -floop-strip-mine -floop-block -fgraphite-identity -ftree-loop-distribution -O3 -pipe -flto=1 -fuse-linker-plugin -ffat-lto-objects"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/libreoffice/program/sofficerc /usr/share/config /usr/share/gnupg/qualified.txt /var/bind"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php7.4/ext-active/ /etc/php/apache2-php8.0/ext-active/ /etc/php/cgi-php7.4/ext-active/ /etc/php/cgi-php8.0/ext-active/ /etc/php/cli-php7.4/ext-active/ /etc/php/cli-php8.0/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-march=native -fomit-frame-pointer -floop-interchange -floop-strip-mine -floop-block -fgraphite-identity -ftree-loop-distribution -O3 -pipe -flto=1 -fuse-linker-plugin -ffat-lto-objects"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS="--with-bdeps=n --complete-graph --binpkg-respect-use=y --binpkg-changed-deps=n --changed-deps=n"
ENV_UNSET="CARGO_HOME DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN GOPATH PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs binpkg-multi-instance buildpkg-live candy ccache config-protect-if-modified distlocks ebuild-locks fixlafiles ipc-sandbox merge-sync multilib-strict network-sandbox news parallel-fetch pid-sandbox preserve-libs protect-owned qa-unresolved-soname-deps sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://mirror.csclub.uwaterloo.ca/gentoo-distfiles/"
LANG="en_US.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j8"
PKGDIR="/mnt/systmp/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/tmp"
SHELL="/bin/bash"
USE="0libedit X a52 a53 aac acc acpi adns aio amd64 amr asm atm audiofile bash-completion bluray branding brotli bzip2 c++0x c++11 cdda cdr cli consolekit cracklib css custom-cflags custom-optimization dav1d dbx declarative default-gold dga dirac dri dri3 dts dv dvd dvdr encode enscript exif faad ffmpeg firefox flac fortran gdu gif glut gmp gstreamer gui gzip http2 iconv imlib io-uring ipc jemalloc jit jpeg jpeg2k kde lame libevent libglvnd libnotify libsamplerate libtirpc libwww lto lv2 lz4 lzma lzo mad matroska matrox mikmod mime minimal mmap mmx mozilla mp3 mp4 mpeg mplayer mpris mudflap multilib networkmanager nntp nocd nptl nptlonly nsplugin offensive ogg openal opengl openmp optimization opus orc osc pam pango pdf pgo phonon pie plasma png pnm policykit posix ppds pppd pulseaudio qt5 quicktime raw readline schroedinger sharedmem shorten smp sndfile sockets socks5 spell split-usr sse sse2 sse3 sse4 sse4_1 sse4_2 ssse3 startup-notification strong-optimization svg svg2 symlink sysfs systemd taglib tcmalloc tfo theora threads tiff toolame truetype twolame udev udisks unicode unixd upower usb vaapi vcd vhosts vorbis vpx wavpack webp widgets win32codecs wxwidgets x264 x265 xcb xine xml xorg xpm xv xvid zlib" ABI_X86="64" ADA_TARGET="gnat_2020" APACHE2_MODULES="unixd authn_core authz_core authz_host access_compat alias auth_basic authn_file log_config mime log_config proxy proxy_http rewrite proxy_balancer lbmethod_bybusyness lbmethod_byrequests lbmethod_bytraffic lbmethod_heartbeat slotmem_shm env cache dir cgid headers proxy_connect" APACHE2_MPMS="event" CALLIGRA_FEATURES="karbon sheets words" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="ssse3 sse3 sse4_1 sse4_2 mmx sse avx mmx sse2 f16c popcnt" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock greis isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="pc" INPUT_DEVICES="evdev" KERNEL="linux" L10N="en" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="nlpsolver pdfimport" LLVM_TARGETS="x86" LUA_SINGLE_TARGET="lua5-1" LUA_TARGETS="lua5-1" NGINX_MODULES_HTTP="access fastcgi gzip gzip_static limit_req rewrite upstream_check proxy" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-4 php8-0" POSTGRES_TARGETS="postgres12 postgres13" PYTHON_SINGLE_TARGET="python3_9" PYTHON_TARGETS="python3_9" QEMU_SOFTMMU_TARGETS="x86_64" RUBY_TARGETS="ruby26" USERLAND="GNU" VIDEO_CARDS="intel i965 i915" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq proto steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  ADDR2LINE, AR, ARFLAGS, AS, ASFLAGS, CC, CCLD, CONFIG_SHELL, CPP, CPPFLAGS, CTARGET, CXX, CXXFILT, ELFEDIT, EXTRA_ECONF, F77FLAGS, FC, GCOV, GPROF, INSTALL_MASK, LC_ALL, LD, LEX, LFLAGS, LIBTOOL, LINGUAS, MAKE, MAKEFLAGS, NM, OBJCOPY, OBJDUMP, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, RANLIB, READELF, RUSTFLAGS, SIZE, STRINGS, STRIP, YACC, YFLAGS
Comment 1 Sam James archtester Gentoo Infrastructure gentoo-dev Security 2022-04-29 09:47:03 UTC
It's unlikely this is related to the latest version, but a bisect would be appreciated in any case if you think it's a recent change.
Comment 2 Zac Medico gentoo-dev 2022-04-30 00:37:59 UTC
It looks like what happened is that qtwebengine failed in [lh(In reply to dE from comment #0)
> Created attachment 775305 [details]
> emerge -j2 --debug --getbinpkg --keep-going --update --deep world &>
> /tmp/crash.log


What happened is that qtwebengine failed in pkg_pretend, and then emerge tried to pull in the installed qtwebengine to satisfy dependencies. The installed qtwebengine required an older version of qtcore than the qtcore-5.15.3 that was scheduled to merge, which triggered this error:

 * One or more packages are either masked or have missing dependencies:
 * 
 *   =dev-qt/qtcore-5.15.2* pulled in by:
 *     (dev-qt/qtwebengine-5.15.2_p20211216-1:5/5.15::gentoo, installed)
Comment 3 Zac Medico gentoo-dev 2022-04-30 00:42:13 UTC
A solution would be for emerge to reconsider the version of qtcore to install after qtwebengine failed in pkg_pretend.